Index: src/binutils/binutils/po/Make-in
===================================================================
RCS file: /gccos2/src/binutils/binutils/po/Make-in,v
retrieving revision 1.1.1.1
retrieving revision 1.3
diff -w -u -r1.1.1.1 -r1.3
--- src/binutils/binutils/po/Make-in	16 Apr 2003 14:15:17 -0000	1.1.1.1
+++ src/binutils/binutils/po/Make-in	30 Jan 2004 16:07:38 -0000	1.3
@@ -30,10 +30,10 @@
 
 CC = @CC@
 GENCAT = @GENCAT@
-GMSGFMT = PATH=../src:$$PATH @GMSGFMT@
+GMSGFMT = PATH="../src@PATH_IFS@$$PATH" @GMSGFMT@
 MSGFMT = @MSGFMT@
-XGETTEXT = PATH=../src:$$PATH @XGETTEXT@
-MSGMERGE = PATH=../src:$$PATH msgmerge
+XGETTEXT = PATH="../src@PATH_IFS@$$PATH" @XGETTEXT@
+MSGMERGE = PATH="../src@PATH_IFS@$$PATH" msgmerge
 
 DEFS = @DEFS@
 CFLAGS = @CFLAGS@
@@ -208,7 +208,7 @@
 
 update-po: Makefile
 	$(MAKE) $(PACKAGE).pot
-	PATH=`pwd`/../src:$$PATH; \
+	PATH="`pwd`/../src@PATH_IFS@$$PATH"; \
 	cd $(srcdir); \
 	catalogs='$(CATALOGS)'; \
 	for cat in $$catalogs; do \
Index: src/binutils/config/mh-emx
===================================================================
RCS file: src/binutils/config/mh-emx
diff -N src/binutils/config/mh-emx
--- nul	1 Jan 1970 00:00:00 -0000
+++ src/binutils/config/mh-emx	3 May 2003 21:45:43 -0000	1.1
@@ -0,0 +1,11 @@
+# We don't want debugging info
+# Accomplish this by overriding CFLAGS.
+CFLAGS=-s -O2
+CXXFLAGS=-s -O2
+LDFLAGS=-s -Zcrtdll -Zexe
+
+# Override SHELL variable (which is CMD.EXE by default)
+SHELL=bash
+
+# No ranlib
+RANLIB=true
Index: src/binutils/gas/as.c
===================================================================
RCS file: /gccos2/src/binutils/gas/as.c,v
retrieving revision 1.1.1.2
retrieving revision 1.6
diff -w -u -r1.1.1.2 -r1.6
--- src/binutils/gas/as.c	16 Aug 2003 16:47:22 -0000	1.1.1.2
+++ src/binutils/gas/as.c	16 Dec 2003 22:09:34 -0000	1.6
@@ -118,6 +118,12 @@
 
 static struct itbl_file_list *itbl_files;
 
+#ifdef EMX
+static char *omf_file_name;
+int emx_omf;                    /* -Zomf */
+int emx_strip;                  /* -Zstrip */
+#endif /* EMX */
+
 #ifdef USE_EMULATIONS
 #define EMULATION_ENVIRON "AS_EMULATION"
 
@@ -797,6 +803,13 @@
   int macro_strip_at;
   int keep_it;
 
+#ifdef __EMX__
+  _emxload_env ("GCCLOAD");
+  _envargs (&argc, &argv, "GASOPT");
+  _response (&argc, &argv);
+  _wildcard (&argc, &argv);
+#endif /* __EMX__ */
+
   start_time = get_run_time ();
 
 #if defined (HAVE_SETLOCALE) && defined (HAVE_LC_MESSAGES)
@@ -841,6 +854,29 @@
   frag_init ();
   subsegs_begin ();
   parse_args (&argc, &argv);
+
+#ifdef EMX
+  if (emx_omf)
+    {
+      char *tmp_dir;
+      size_t tmp_dir_len;
+
+      omf_file_name = out_file_name;
+      tmp_dir = getenv ("TMPDIR");
+      if (tmp_dir == NULL) tmp_dir = getenv ("TMP");
+      if (tmp_dir == NULL) tmp_dir = getenv ("TEMP");
+      if (tmp_dir == NULL) tmp_dir = ".";
+      tmp_dir_len = strlen (tmp_dir);
+      out_file_name = xmalloc (tmp_dir_len + 10);
+      memcpy (out_file_name, tmp_dir, tmp_dir_len);
+      if (tmp_dir_len != 0 && strchr ("\\/:", tmp_dir[tmp_dir_len-1]) == NULL)
+        out_file_name[tmp_dir_len++] = '\\';
+      strcpy (out_file_name + tmp_dir_len, "asXXXXXX");
+      if (mktemp (out_file_name) == NULL)
+        as_fatal ("mktemp() failed");
+    }
+#endif /* EMX */
+
   read_begin ();
   input_scrub_begin ();
   expr_begin ();
@@ -942,6 +978,29 @@
 
   if (!keep_it)
     unlink (out_file_name);
+
+#ifdef EMX
+  if (keep_it && emx_omf)
+    {
+      int rc, i;
+      char *args[6];
+
+      i = 0;
+      args[i++] = "emxomf";
+      if (emx_strip)
+      args[i++] = "-s";
+      args[i++] = "-o";
+      args[i++] = omf_file_name;
+      args[i++] = out_file_name;
+      args[i] = NULL;
+      rc = spawnvp (P_WAIT, "emxomf.exe", args);
+      remove (out_file_name);
+      if (rc < 0)
+        as_fatal ("cannot run emxomf");
+      else if (rc > 0)
+        as_fatal ("emxomf failed");
+    }
+#endif /* EMX */
 
   input_scrub_end ();
 
Index: src/binutils/gas/configure.in
===================================================================
RCS file: /gccos2/src/binutils/gas/configure.in,v
retrieving revision 1.1.1.2
retrieving revision 1.4
diff -w -u -r1.1.1.2 -r1.4
--- src/binutils/gas/configure.in	16 Aug 2003 16:48:02 -0000	1.1.1.2
+++ src/binutils/gas/configure.in	15 Feb 2004 03:16:58 -0000	1.4
@@ -297,6 +297,8 @@
       i386-*-mingw32*)			fmt=coff em=pe ;;
       i386-*-nto-qnx*)			fmt=elf ;;
       i386-*-*nt*)			fmt=coff em=pe ;;
+      i386-*-os2-elf*)       fmt=elf ;;
+      i386-*-os2*)          fmt=aout em=emx bfd_gas=yes ;;
       i386-*-vxworks*)			fmt=aout ;;
       i386-*-chaos)			fmt=elf ;;
 
Index: src/binutils/gas/config/tc-i386.c
===================================================================
RCS file: /gccos2/src/binutils/gas/config/tc-i386.c,v
retrieving revision 1.1.1.2
retrieving revision 1.3
diff -w -u -r1.1.1.2 -r1.3
--- src/binutils/gas/config/tc-i386.c	16 Aug 2003 16:49:10 -0000	1.1.1.2
+++ src/binutils/gas/config/tc-i386.c	16 Aug 2003 21:33:51 -0000	1.3
@@ -4883,10 +4883,21 @@
 #define OPTION_64 (OPTION_MD_BASE + 1)
   {"64", no_argument, NULL, OPTION_64},
 #endif
+#ifdef EMX
+#define OPTION_ZOMF (OPTION_MD_BASE + 1)
+  {"Zomf", no_argument, NULL, OPTION_ZOMF},
+#define OPTION_ZSTRIP (OPTION_MD_BASE + 2)
+  {"Zstrip", no_argument, NULL, OPTION_ZSTRIP},
+#endif /* EMX */
   {NULL, no_argument, NULL, 0}
 };
 size_t md_longopts_size = sizeof (md_longopts);
 
+#ifdef EMX
+extern int emx_omf;
+extern int emx_strip;
+#endif /* EMX */
+
 int
 md_parse_option (c, arg)
      int c;
@@ -4939,6 +4950,16 @@
     case OPTION_32:
       default_arch = "i386";
       break;
+
+#ifdef EMX
+    case OPTION_ZOMF:
+      emx_omf = 1;
+      break;
+
+    case OPTION_ZSTRIP:
+      emx_strip = 1;
+      break;
+#endif /* EMX */
 
     default:
       return 0;
Index: src/binutils/gas/config/tc-i386.h
===================================================================
RCS file: /gccos2/src/binutils/gas/config/tc-i386.h,v
retrieving revision 1.1.1.2
retrieving revision 1.3
diff -w -u -r1.1.1.2 -r1.3
--- src/binutils/gas/config/tc-i386.h	16 Aug 2003 16:49:11 -0000	1.1.1.2
+++ src/binutils/gas/config/tc-i386.h	16 Aug 2003 21:33:51 -0000	1.3
@@ -56,6 +56,9 @@
 #ifdef TE_DYNIX
 #define AOUT_TARGET_FORMAT	"a.out-i386-dynix"
 #endif
+#ifdef TE_EMX
+#define AOUT_TARGET_FORMAT	"a.out-emx"
+#endif
 #ifndef AOUT_TARGET_FORMAT
 #define AOUT_TARGET_FORMAT	"a.out-i386"
 #endif
Index: src/binutils/gas/config/te-emx.h
===================================================================
RCS file: src/binutils/gas/config/te-emx.h
diff -N src/binutils/gas/config/te-emx.h
--- nul	1 Jan 1970 00:00:00 -0000
+++ src/binutils/gas/config/te-emx.h	17 Aug 2003 01:42:48 -0000	1.3
@@ -0,0 +1,12 @@
+#define TE_EMX
+
+#undef abort
+#include <process.h>
+#include <io.h>
+#define abort()		as_abort (__FILE__, __LINE__, __PRETTY_FUNCTION__)
+
+#define LEX_AT 1 /* can have @'s inside labels */
+#define EMX
+#define LOCAL_LABELS_DOLLAR     1
+
+#include "obj-format.h"
Index: src/binutils/gas/po/Make-in
===================================================================
RCS file: /gccos2/src/binutils/gas/po/Make-in,v
retrieving revision 1.1.1.1
retrieving revision 1.3
diff -w -u -r1.1.1.1 -r1.3
--- src/binutils/gas/po/Make-in	16 Apr 2003 14:15:20 -0000	1.1.1.1
+++ src/binutils/gas/po/Make-in	30 Jan 2004 16:07:38 -0000	1.3
@@ -30,10 +30,10 @@
 
 CC = @CC@
 GENCAT = @GENCAT@
-GMSGFMT = PATH=../src:$$PATH @GMSGFMT@
+GMSGFMT = PATH="../src@PATH_IFS@$$PATH" @GMSGFMT@
 MSGFMT = @MSGFMT@
-XGETTEXT = PATH=../src:$$PATH @XGETTEXT@
-MSGMERGE = PATH=../src:$$PATH msgmerge
+XGETTEXT = PATH="../src@PATH_IFS@$$PATH" @XGETTEXT@
+MSGMERGE = PATH="../src@PATH_IFS@$$PATH" msgmerge
 
 DEFS = @DEFS@
 CFLAGS = @CFLAGS@
@@ -208,7 +208,7 @@
 
 update-po: Makefile
 	$(MAKE) $(PACKAGE).pot
-	PATH=`pwd`/../src:$$PATH; \
+	PATH="`pwd`/../src@PATH_IFS@$$PATH"; \
 	cd $(srcdir); \
 	catalogs='$(CATALOGS)'; \
 	for cat in $$catalogs; do \
Index: src/binutils/gprof/configure.in
===================================================================
RCS file: /gccos2/src/binutils/gprof/configure.in,v
retrieving revision 1.1.1.2
retrieving revision 1.2
diff -w -u -r1.1.1.2 -r1.2
--- src/binutils/gprof/configure.in	16 Aug 2003 16:54:31 -0000	1.1.1.2
+++ src/binutils/gprof/configure.in	26 Oct 2003 05:57:33 -0000	1.2
@@ -23,7 +23,7 @@
 
 AC_CHECK_FUNCS(setmode)
 
-ALL_LINGUAS="fr tr sv es id da pt_BR"
+ALL_LINGUAS="fr sv es id da pt_BR"
 CY_GNU_GETTEXT
 
 AM_MAINTAINER_MODE
Index: src/binutils/gprof/gmon.h
===================================================================
RCS file: /gccos2/src/binutils/gprof/gmon.h,v
retrieving revision 1.1.1.2
retrieving revision 1.3
diff -w -u -r1.1.1.2 -r1.3
--- src/binutils/gprof/gmon.h	16 Aug 2003 16:54:32 -0000	1.1.1.2
+++ src/binutils/gprof/gmon.h	16 Aug 2003 21:33:53 -0000	1.3
@@ -79,8 +79,13 @@
 
 /*
  * Histogram counters are unsigned shorts:
+ * For emx, histogram counters are unsigned longs.
  */
+#ifdef EMX
+#define	HISTCOUNTER unsigned long
+#else
 #define	HISTCOUNTER unsigned short
+#endif
 
 /*
  * Fraction of text space to allocate for histogram counters here, 1/2:
Index: src/binutils/gprof/hertz.h
===================================================================
RCS file: /gccos2/src/binutils/gprof/hertz.h,v
retrieving revision 1.1.1.2
retrieving revision 1.3
diff -w -u -r1.1.1.2 -r1.3
--- src/binutils/gprof/hertz.h	16 Aug 2003 16:54:39 -0000	1.1.1.2
+++ src/binutils/gprof/hertz.h	16 Aug 2003 21:33:53 -0000	1.3
@@ -1,6 +1,10 @@
 #ifndef hertz_h
 #define hertz_h
 
+#ifdef __EMX__
+#define HERTZ (_osmode == OS2_MODE ? 1000 : 1024)
+#endif
+
 #define	HZ_WRONG 0		/* impossible clock frequency */
 
 /*
Index: src/binutils/gprof/po/Make-in
===================================================================
RCS file: /gccos2/src/binutils/gprof/po/Make-in,v
retrieving revision 1.1.1.2
retrieving revision 1.3
diff -w -u -r1.1.1.2 -r1.3
--- src/binutils/gprof/po/Make-in	16 Aug 2003 16:54:43 -0000	1.1.1.2
+++ src/binutils/gprof/po/Make-in	30 Jan 2004 16:07:38 -0000	1.3
@@ -30,10 +30,10 @@
 
 CC = @CC@
 GENCAT = @GENCAT@
-GMSGFMT = PATH=../src:$$PATH @GMSGFMT@
+GMSGFMT = PATH="../src@PATH_IFS@$$PATH" @GMSGFMT@
 MSGFMT = @MSGFMT@
-XGETTEXT = PATH=../src:$$PATH @XGETTEXT@
-MSGMERGE = PATH=../src:$$PATH msgmerge
+XGETTEXT = PATH="../src@PATH_IFS@$$PATH" @XGETTEXT@
+MSGMERGE = PATH="../src@PATH_IFS@$$PATH" msgmerge
 
 DEFS = @DEFS@
 CFLAGS = @CFLAGS@
@@ -210,7 +210,7 @@
 
 update-po: Makefile
 	$(MAKE) $(PACKAGE).pot
-	PATH=`pwd`/../src:$$PATH; \
+	PATH="`pwd`/../src@PATH_IFS@$$PATH"; \
 	cd $(srcdir); \
 	catalogs='$(CATALOGS)'; \
 	for cat in $$catalogs; do \
Index: src/binutils/include/getopt.h
===================================================================
RCS file: /gccos2/src/binutils/include/getopt.h,v
retrieving revision 1.1.1.2
retrieving revision 1.2
diff -w -u -r1.1.1.2 -r1.2
--- src/binutils/include/getopt.h	16 Aug 2003 16:54:48 -0000	1.1.1.2
+++ src/binutils/include/getopt.h	17 Aug 2003 01:43:30 -0000	1.2
@@ -106,7 +106,7 @@
    to find the declaration so provide a fully prototyped one.  If it
    is 1, we found it so don't provide any declaration at all.  */
 #if !HAVE_DECL_GETOPT
-#if defined (__GNU_LIBRARY__) || defined (HAVE_DECL_GETOPT)
+#if defined (__GNU_LIBRARY__) || defined (HAVE_DECL_GETOPT) || defined (__EMX__)
 /* Many other libraries have conflicting prototypes for getopt, with
    differences in the consts, in unistd.h.  To avoid compilation
    errors, only prototype getopt for the GNU C library.  */
Index: src/binutils/include/libiberty.h
===================================================================
RCS file: /gccos2/src/binutils/include/libiberty.h,v
retrieving revision 1.1.1.2
retrieving revision 1.2
diff -w -u -r1.1.1.2 -r1.2
--- src/binutils/include/libiberty.h	16 Aug 2003 16:54:50 -0000	1.1.1.2
+++ src/binutils/include/libiberty.h	17 Aug 2003 01:44:43 -0000	1.2
@@ -74,7 +74,7 @@
    to find the declaration so provide a fully prototyped one.  If it
    is 1, we found it so don't provide any declaration at all.  */
 #if !HAVE_DECL_BASENAME
-#if defined (__GNU_LIBRARY__ ) || defined (__linux__) || defined (__FreeBSD__) || defined (__OpenBSD__) || defined(__NetBSD__) || defined (__CYGWIN__) || defined (__CYGWIN32__) || defined (HAVE_DECL_BASENAME)
+#if defined (__GNU_LIBRARY__ ) || defined (__linux__) || defined (__FreeBSD__) || defined (__OpenBSD__) || defined(__NetBSD__) || defined (__CYGWIN__) || defined (__CYGWIN32__) || defined (__EMX__) || defined (HAVE_DECL_BASENAME)
 extern char *basename PARAMS ((const char *));
 #else
 extern char *basename ();
Index: src/binutils/include/aout/aout64.h
===================================================================
RCS file: /gccos2/src/binutils/include/aout/aout64.h,v
retrieving revision 1.1.1.2
retrieving revision 1.6
diff -w -u -r1.1.1.2 -r1.6
--- src/binutils/include/aout/aout64.h	16 Aug 2003 16:54:53 -0000	1.1.1.2
+++ src/binutils/include/aout/aout64.h	6 Jun 2005 02:42:09 -0000	1.6
@@ -331,6 +331,11 @@
 #define N_WEAKD 0x10		/* Weak data symbol.  */
 #define N_WEAKB 0x11		/* Weak bss symbol.  */
 
+/* emx-specific symbols.  */
+#define N_IMP1 0x68		/* Import reference (emx specific) */
+#define N_IMP2 0x6a		/* Import definition (emx specific) */
+#define N_EXP  0x6c             /* Export definition (emx specific) */
+
 /* Relocations 
 
   There	are two types of relocation flavours for a.out systems,
Index: src/binutils/include/aout/aoutemx.h
===================================================================
RCS file: src/binutils/include/aout/aoutemx.h
diff -N src/binutils/include/aout/aoutemx.h
--- nul	1 Jan 1970 00:00:00 -0000
+++ src/binutils/include/aout/aoutemx.h	6 Jun 2005 02:42:09 -0000	1.2
@@ -0,0 +1,26 @@
+/* traditional EMX a.out format differences for i386 running OS/2 or DOS */
+
+#define SEGMENT_SIZE 0x10000
+
+#define N_HEADER_IN_TEXT(x) 0
+
+#define	N_TXTSIZE(x) ((x).a_text)
+#define N_TXTOFF(x)	\
+    (N_MAGIC(x) != ZMAGIC ? EXEC_BYTES_SIZE : /* object file or NMAGIC */\
+     0x400 + (x).a_hdrofs \
+    )
+
+#define N_DATOFF(x) (N_TXTOFF(x) + N_TXTSIZE(x))
+
+/* Address of text segment in memory after it is loaded.  */
+#define N_TXTADDR(x) \
+    (N_MAGIC(x) != ZMAGIC ? 0 : SEGMENT_SIZE)
+#define N_DATADDR(x) \
+    (N_MAGIC(x) == OMAGIC ? \
+     (N_TXTADDR (x) + (x).a_text) : \
+     ((N_TXTADDR(x) + (x).a_text + SEGMENT_SIZE - 1) & ~(SEGMENT_SIZE - 1)))
+
+/* EMX-specific symbols.  */
+#define N_IMP1 0x68		/* Import reference (emx specific) */
+#define N_IMP2 0x6a		/* Import definition (emx specific) */
+#define N_EXP  0x6c		/* Export definition (emx specific) */
Index: src/binutils/ld/configure.host
===================================================================
RCS file: /gccos2/src/binutils/ld/configure.host,v
retrieving revision 1.1.1.2
retrieving revision 1.3
diff -w -u -r1.1.1.2 -r1.3
--- src/binutils/ld/configure.host	16 Aug 2003 16:55:49 -0000	1.1.1.2
+++ src/binutils/ld/configure.host	16 Aug 2003 21:33:53 -0000	1.3
@@ -225,4 +225,7 @@
   HOSTING_CRT0=/usr/ccs/lib/crt0.o
   ;;
 
+*-*-os2*)
+  HLDFLAGS="-s -Zexe -Zcrtdll"
+  NATIVE_LIB_DIRS=/emx/lib
 esac
Index: src/binutils/ld/configure.in
===================================================================
RCS file: /gccos2/src/binutils/ld/configure.in,v
retrieving revision 1.1.1.2
retrieving revision 1.2
diff -w -u -r1.1.1.2 -r1.2
--- src/binutils/ld/configure.in	16 Aug 2003 16:55:49 -0000	1.1.1.2
+++ src/binutils/ld/configure.in	26 Oct 2003 06:02:28 -0000	1.2
@@ -101,7 +101,7 @@
 AC_PROG_CC
 AC_PROG_INSTALL
 
-ALL_LINGUAS="fr sv tr es da"
+ALL_LINGUAS="fr sv es da"
 CY_GNU_GETTEXT
 
 AC_EXEEXT
Index: src/binutils/ld/configure.tgt
===================================================================
RCS file: /gccos2/src/binutils/ld/configure.tgt,v
retrieving revision 1.1.1.2
retrieving revision 1.5
diff -w -u -r1.1.1.2 -r1.5
--- src/binutils/ld/configure.tgt	16 Aug 2003 16:55:49 -0000	1.1.1.2
+++ src/binutils/ld/configure.tgt	16 Feb 2004 03:44:13 -0000	1.5
@@ -188,6 +188,18 @@
 			esac
 			;;
 i[3456]86-*-netware)	targ_emul=i386nw ;;
+i[3456]86-*-os2-elf)	targ_emul=elf_i386;
+            targ_extra_emuls="i386aoutemx i386pe";
+            tdir_elf_i386=${targ_alias};
+            tdir_i386emx=${targ_alias}aout;
+			targ_extra_ofiles="deffilep.o pe-dll.o";
+            ;;
+i[3456]86-*-os2 | i[3456]86-*-os2-emx)  targ_emul=i386aoutemx;
+            targ_extra_emuls="elf_i386 i386pe";
+            tdir_i386emx=${targ_alias};
+            tdir_elf_i386=${targ_alias}elf;
+			targ_extra_ofiles="deffilep.o pe-dll.o";
+            ;;
 i[3456]86-*-elf*)	targ_emul=elf_i386 ;;
 i[3456]86-*-kaos*)	targ_emul=elf_i386 ;;
 i[3456]86-*-freebsdaout* | i[3456]86-*-freebsd[12].* | i[3456]86-*-freebsd[12])
Index: src/binutils/ld/ldctor.c
===================================================================
RCS file: /gccos2/src/binutils/ld/ldctor.c,v
retrieving revision 1.1.1.2
retrieving revision 1.5
diff -w -u -r1.1.1.2 -r1.5
--- src/binutils/ld/ldctor.c	16 Aug 2003 16:56:04 -0000	1.1.1.2
+++ src/binutils/ld/ldctor.c	25 Sep 2003 19:27:01 -0000	1.5
@@ -361,8 +361,10 @@
 
 	      if (e->name != NULL)
 		minfo ("%T\n", e->name);
-	      else
+	      else if (e->section->owner != NULL)
 		minfo ("%G\n", e->section->owner, e->section, e->value);
+              else
+		minfo ("*unknown*\n");
 	    }
 
 	  /* Need SEC_KEEP for --gc-sections.  */
Index: src/binutils/ld/ldemul.c
===================================================================
RCS file: /gccos2/src/binutils/ld/ldemul.c,v
retrieving revision 1.1.1.2
retrieving revision 1.4
diff -w -u -r1.1.1.2 -r1.4
--- src/binutils/ld/ldemul.c	16 Aug 2003 16:56:04 -0000	1.1.1.2
+++ src/binutils/ld/ldemul.c	16 Aug 2003 21:33:53 -0000	1.4
@@ -339,3 +339,11 @@
     entry = (*ld_emulation->new_vers_pattern) (entry);
   return entry;
 }
+
+/* Added by the EMX/OS2 port */
+void
+ldemul_finish_link (char *filename)
+{
+ if (ld_emulation->finish_link)
+  ld_emulation->finish_link (filename);
+}
Index: src/binutils/ld/ldemul.h
===================================================================
RCS file: /gccos2/src/binutils/ld/ldemul.h,v
retrieving revision 1.1.1.2
retrieving revision 1.4
diff -w -u -r1.1.1.2 -r1.4
--- src/binutils/ld/ldemul.h	16 Aug 2003 16:56:05 -0000	1.1.1.2
+++ src/binutils/ld/ldemul.h	16 Aug 2003 21:33:53 -0000	1.4
@@ -184,6 +184,10 @@
   struct bfd_elf_version_expr * (*new_vers_pattern)
     PARAMS ((struct bfd_elf_version_expr *));
 
+  /* Perform final action(s) on output file
+     Note: Added by the EMX/OS2 port, so keep it at the end! */
+  void (*finish_link) PARAMS ((char *));
+
 } ld_emulation_xfer_type;
 
 typedef enum {
Index: src/binutils/ld/ldfile.c
===================================================================
RCS file: /gccos2/src/binutils/ld/ldfile.c,v
retrieving revision 1.1.1.2
retrieving revision 1.5
diff -w -u -r1.1.1.2 -r1.5
--- src/binutils/ld/ldfile.c	16 Aug 2003 16:56:05 -0000	1.1.1.2
+++ src/binutils/ld/ldfile.c	16 Feb 2004 03:42:39 -0000	1.5
@@ -353,9 +353,75 @@
 				 + strlen (entry->filename)
 				 + strlen (arch)
 				 + strlen (suffix)
+#if defined (__EMX__) /* Target feature really, but no target define to test on. */
+				 + 16);
+#else
 				 + 1);
+#endif
+
+#if defined (__EMX__) /* Target feature really, but no target define to test on. */
+      /* On OS/2 we have a complex naming scheme for libraries. They may have a
+         prefix, we prefere the ones with. They may also have special suffixes
+         depending on the library type. _s.a mean static, _dll.a mean dynaminc,
+         plain .a might mean both and should be searched last.
+
+         TODO: make a ldemul_open_static_archive(). */
+
+      if (entry->is_archive)
+	sprintf (string, "%s%s%s%s%s%s%s", search->name, slash,
+		 lib, entry->filename, arch,
+		 (entry->dynamic && ! link_info.relocateable ? "" : "_s"),
+                 suffix);
+      else
+	sprintf (string, "%s%s%s", search->name, slash, entry->filename);
+
+      if (ldfile_try_open_bfd (string, entry))
+	{
+	  entry->filename = string;
+	  entry->sysrooted = search->sysrooted;
+	  return TRUE;
+	}
 
       if (entry->is_archive)
+        {
+          /* without lib prefix. */
+          sprintf (string, "%s%s%s%s%s%s", search->name, slash,
+                   entry->filename, arch,
+                   (entry->dynamic && ! link_info.relocateable ? "" : "_s"),
+                   suffix);
+          if (ldfile_try_open_bfd (string, entry))
+    	    {
+    	      entry->filename = string;
+    	      entry->sysrooted = search->sysrooted;
+    	      return TRUE;
+    	    }
+
+          /* inverse the "_s". */
+          sprintf (string, "%s%s%s%s%s%s%s", search->name, slash,
+                   lib, entry->filename, arch,
+                   (entry->dynamic && ! link_info.relocateable ? "_s" : ""),
+                   suffix);
+          if (ldfile_try_open_bfd (string, entry))
+    	    {
+    	      entry->filename = string;
+    	      entry->sysrooted = search->sysrooted;
+    	      return TRUE;
+    	    }
+
+          /* without lib prefix and inverse "_s". */
+          sprintf (string, "%s%s%s%s%s%s", search->name, slash,
+                   entry->filename, arch,
+                   (entry->dynamic && ! link_info.relocateable ? "_s" : ""),
+                   suffix);
+          if (ldfile_try_open_bfd (string, entry))
+    	    {
+    	      entry->filename = string;
+    	      entry->sysrooted = search->sysrooted;
+    	      return TRUE;
+    	    }
+        }
+#else /* __EMX__ ^ */
+      if (entry->is_archive)
 	sprintf (string, "%s%s%s%s%s%s", search->name, slash,
 		 lib, entry->filename, arch, suffix);
       else
@@ -367,6 +433,8 @@
 	  entry->sysrooted = search->sysrooted;
 	  return TRUE;
 	}
+#endif /* __EMX__ */
+
 
       free (string);
     }
Index: src/binutils/ld/ldmain.c
===================================================================
RCS file: /gccos2/src/binutils/ld/ldmain.c,v
retrieving revision 1.1.1.2
retrieving revision 1.4
diff -w -u -r1.1.1.2 -r1.4
--- src/binutils/ld/ldmain.c	16 Aug 2003 16:56:16 -0000	1.1.1.2
+++ src/binutils/ld/ldmain.c	16 Aug 2003 21:33:53 -0000	1.4
@@ -190,7 +190,12 @@
   bindtextdomain (PACKAGE, LOCALEDIR);
   textdomain (PACKAGE);
 
+#ifdef __EMX__
+  _response (&argc, &argv);
+  program_name = _getname(argv[0]);
+#else
   program_name = argv[0];
+#endif
   xmalloc_set_program_name (program_name);
 
   START_PROGRESS (program_name, 0);
@@ -500,6 +505,10 @@
     {
       if (! bfd_close (output_bfd))
 	einfo (_("%F%B: final close failed: %E\n"), output_bfd);
+
+      /* Perform the final actions on output file
+       * (Added by the EMX/OS2 port) */
+      ldemul_finish_link (output_filename);
 
       /* If the --force-exe-suffix is enabled, and we're making an
 	 executable file and it doesn't end in .exe, copy it to one
Index: src/binutils/ld/emulparams/i386aoutemx.sh
===================================================================
RCS file: src/binutils/ld/emulparams/i386aoutemx.sh
diff -N src/binutils/ld/emulparams/i386aoutemx.sh
--- nul	1 Jan 1970 00:00:00 -0000
+++ src/binutils/ld/emulparams/i386aoutemx.sh	3 May 2003 21:45:43 -0000	1.1
@@ -0,0 +1,8 @@
+ARCH=i386
+SCRIPT_NAME=i386aoutemx
+TEMPLATE_NAME=i386aoutemx
+OUTPUT_FORMAT="a.out-emx"
+TARGET_PAGE_SIZE=0x1000
+TEXT_START_ADDR=0x10000
+SEGMENT_SIZE=0x10000
+LIB_PATH=${NATIVE_LIB_DIRS}
Index: src/binutils/ld/po/Make-in
===================================================================
RCS file: /gccos2/src/binutils/ld/po/Make-in,v
retrieving revision 1.1.1.1
retrieving revision 1.3
diff -w -u -r1.1.1.1 -r1.3
--- src/binutils/ld/po/Make-in	16 Apr 2003 14:15:27 -0000	1.1.1.1
+++ src/binutils/ld/po/Make-in	30 Jan 2004 16:07:38 -0000	1.3
@@ -30,10 +30,10 @@
 
 CC = @CC@
 GENCAT = @GENCAT@
-GMSGFMT = PATH=../src:$$PATH @GMSGFMT@
+GMSGFMT = PATH="../src@PATH_IFS@$$PATH" @GMSGFMT@
 MSGFMT = @MSGFMT@
-XGETTEXT = PATH=../src:$$PATH @XGETTEXT@
-MSGMERGE = PATH=../src:$$PATH msgmerge
+XGETTEXT = PATH="../src@PATH_IFS@$$PATH" @XGETTEXT@
+MSGMERGE = PATH="../src@PATH_IFS@$$PATH" msgmerge
 
 DEFS = @DEFS@
 CFLAGS = @CFLAGS@
@@ -208,7 +208,7 @@
 
 update-po: Makefile
 	$(MAKE) $(PACKAGE).pot
-	PATH=`pwd`/../src:$$PATH; \
+	PATH="`pwd`/../src@PATH_IFS@$$PATH"; \
 	cd $(srcdir); \
 	catalogs='$(CATALOGS)'; \
 	for cat in $$catalogs; do \
Index: src/binutils/ld/scripttempl/i386aoutemx.sc
===================================================================
RCS file: src/binutils/ld/scripttempl/i386aoutemx.sc
diff -N src/binutils/ld/scripttempl/i386aoutemx.sc
--- nul	1 Jan 1970 00:00:00 -0000
+++ src/binutils/ld/scripttempl/i386aoutemx.sc	3 May 2003 21:45:43 -0000	1.1
@@ -0,0 +1,38 @@
+cat <<EOF
+OUTPUT_FORMAT("${OUTPUT_FORMAT}")
+OUTPUT_ARCH(${ARCH})
+
+${RELOCATING+${LIB_SEARCH_DIRS}}
+${STACKZERO+${RELOCATING+${STACKZERO}}}
+${SHLIB_PATH+${RELOCATING+${SHLIB_PATH}}}
+${RELOCATING+${EXECUTABLE_SYMBOLS}}
+${RELOCATING+PROVIDE (__stack = 0);}
+SECTIONS
+{
+  ${RELOCATING+. = ${TEXT_START_ADDR};}
+  .text :
+  {
+    CREATE_OBJECT_SYMBOLS
+    *(.text)
+    ${RELOCATING+_etext = .;}
+    ${RELOCATING+__etext = .;}
+    ${PAD_TEXT+${RELOCATING+. = ${DATA_ALIGNMENT};}}
+  } = 0x90
+  ${RELOCATING+. = ${DATA_ALIGNMENT};}
+  .data :
+  {
+    *(.data)
+    ${CONSTRUCTING+CONSTRUCTORS}
+    ${RELOCATING+_edata  =  .;}
+    ${RELOCATING+__edata  =  .;}
+  } = 0
+  .bss :
+  {
+   ${RELOCATING+ __bss_start = .};
+   *(.bss)
+   *(COMMON)
+   ${RELOCATING+_end = ALIGN(4) };
+   ${RELOCATING+__end = ALIGN(4) };
+  } = 0
+}
+EOF
Index: src/binutils/libiberty/basename.c
===================================================================
RCS file: /gccos2/src/binutils/libiberty/basename.c,v
retrieving revision 1.1.1.2
retrieving revision 1.2
diff -w -u -r1.1.1.2 -r1.2
--- src/binutils/libiberty/basename.c	16 Aug 2003 16:57:20 -0000	1.1.1.2
+++ src/binutils/libiberty/basename.c	3 May 2004 01:29:17 -0000	1.2
@@ -21,7 +21,7 @@
 #endif
 
 #if defined (_WIN32) || defined (__MSDOS__) || defined (__DJGPP__) || \
-  defined (__OS2__)
+  defined (__OS2__) || defined (__EMX__)
 #define HAVE_DOS_BASED_FILE_SYSTEM
 #ifndef DIR_SEPARATOR_2 
 #define DIR_SEPARATOR_2 '\\'
Index: src/binutils/libiberty/config.table
===================================================================
RCS file: /gccos2/src/binutils/libiberty/config.table,v
retrieving revision 1.1.1.2
retrieving revision 1.2
diff -w -u -r1.1.1.2 -r1.2
--- src/binutils/libiberty/config.table	16 Aug 2003 16:57:26 -0000	1.1.1.2
+++ src/binutils/libiberty/config.table	17 Aug 2003 01:48:15 -0000	1.2
@@ -12,6 +12,7 @@
   *-*-freebsd2.2.[012])	frag=mh-fbsd21 ;;
   i370-*-opened*)       frag=mh-openedition ;;
   i[345]86-*-windows*)	frag=mh-windows ;;
+  *-*-*emx)		frag=mh-emx ;;
 esac
 
 if [ -n "${frag}" ]; then
@@ -31,6 +32,7 @@
   frag=
   case "${host}" in
     *-*-cygwin*)	;;
+    *-*-*emx)		;;
     alpha*-*-linux*)	frag=mh-elfalphapic ;;
     arm*-*-*)		frag=mh-armpic ;;
     hppa*-*-*)		frag=mh-papic ;;
